$Hotel::RoomDatabase=0;
$Hotel::RoomDatabase::Count=0;
function serverCmdMittHotel(%client){
	if(!%client.isHost)
		return;
	exec("add-ons/gamemode_mitt-hotel/server.cs");
}
datablock fxDtsBrickData (brickHotelRoom : brick2x2fData)
{
	uiName = "Room Teleport";
	category = "Special";
	subCategory = "Mitt-Hotel";
	indestructable = 1;
};
datablock fxDtsBrickData (brickHotelFloor : brick2x2fData)
{
	uiName = "Floor Teleport";
	category = "Special";
	subCategory = "Mitt-Hotel";
	indestructable = 1;
};
function brickHotelRoom::onPlant(%data,%obj){
	%obj.setNTObjectName("Room_0");
	Parent::onPlant(%data,%obj);
	if(!%obj.client.isAdmin){
		centerPrintClient(%client,"You must be an admin to plant that brick");
		%obj.delete();
	}
}
function brickHotelFloor::onPlant(%data,%obj){
	%obj.setNTObjectName("Floor_1");
	Parent::onPlant(%data,%obj);
	if(!%obj.client.isAdmin){
		centerPrintClient(%client,"You must be an admin to plant that brick");
		%obj.delete();
	}
}
function serverCmdFloor(%client,%floor){
	if(!isObject("_Floor_" @ %floor)){
		messageClient(%client,'',"The floor you attempted to teleport to is invalid.");
		return;
	}
	messageClient(%client,'',"\c6Teleported to floor \c0" @ %floor);
	%floor="_Floor_"@ %floor;
	%floor.setPlayerTransform(0,0,0,%client);
}
function serverCmdRoom(%client,%room){
	if(!isObject("_Room_" @ %room)){
		messageClient(%client,'',"The room you attempted to teleport to is invalid");
		return;
	}
	//keep going if the room exists
	%room2="_Room_" @ %room;
	if(!%client.isAdmin && getTrustLevel(%client,findclientbybl_id(%room2.owner))==0){
		messageClient(%client,'',"You do not have build trust with "@ %room2.client.name);
		return;
	}
	//keep going if the client is trusted by the room owner
	messageClient(%client,'',"\c6You teleported to room \c0" @ %room);
	%room2.setPlayerTransform(0,0,0,%client);
}
function serverCmdGiveRoom(%client,%targ,%room2){
	if(!%client.isAdmin){//is the client even allowed to use this?
		messageClient(%client,'',"You must be an admin to give someone a room.");
		return;
	}
	%target=findclientbyname(%targ);
	if(!isObject(%target)){//is the target online?
		messageClient(%client,'',"That player does not exist!");
		return;
	}
	if(!isObject(%target.player)){//is the target alive?
		messageClient(%client,'',"That player isn't alive!");
		return;
	}
	%door="_Door_" @ %room2;
	%room="_Room_" @ %room2;
	if(!isObject(%door)||!isObject(%room)){//is the room real?
		messageClient(%client,'',"The specified room does not exist or doesn't have a door");
		return;
	}
	if(%room.owner){//is the room owned?
		messageClient(%client,'',"That room already has an owner!");
		return;
	}
	$Hotel::RoomDatabase[%room2]=%room;
	%room.owner=%target.BL_ID;
	%door.owner=%target.BL_ID;
	$Hotel::RoomDatabase::Count++;
	messageClient(%client,'',"\c6You granted\c0" SPC %target.name SPC "\c6room\c0" SPC %room2);
	messageClient(%target,'', %client.name SPC "\c6gave you room" SPC %room2);
	%door.VCE_modVariable(0,"owner",0,%target.BL_ID,%client);
}
function fxDTSBrick::hotelDoorCheck(%this,%client){
	if(!isObject(%this))
		return;
	if(!isObject(%client.player))
		return;
	$InputTarget_Self=%this;
	$InputTarget_Player=%client.player;
	$InputTarget_Client=%client;
	if(!%this.owner || getTrustLevel(findclientbybl_id(%this.owner),%client)==0){
		%this.processInputEvent("onHotelCheckFailure",%client);
		return;
	}
	%this.processInputEvent("onHotelCheckSuccess",%client);
}
registerOutputEvent("fxDTSBrick","hotelDoorCheck","",1);
registerInputEvent("fxDTSBrick","onHotelCheckSuccess","Self fxDTSBrick	Player Player	Client GameConnection	MiniGame MiniGame");
registerInputEvent("fxDTSBrick","onHotelCheckFailure","Self fxDTSBrick	Player Player	Client GameConnection	MiniGame MiniGame");
function serverCmdRevokeRoom(%client,%room2){
	%door="_Door_" @ %room2;
	%room="_Room_" @ %room2;
	if(!isObject(%door)||!isObject(%room)){//is the room real?
		messageClient(%client,'',"The specified room does not exist or doesn't have a door");
		return;
	}
	if(!%room.owner){//is the room unowned?
		messageClient(%client,'',"That room doesn't have an owner!");
		return;
	}
	$Hotel::RoomDatabase[%room2]="";
	%room.owner = -1;
	%door.owner = -1;
	$Hotel::RoomDatabase::Count--;
	messageClient(%client,'',"\c6You made room\c0"SPC %room2 SPC"\c6unoccupied");
}
function serverCmdHotelHelp(%client){
	messageClient(%client,'',"<color:ffffff>Here is some help for building with the hotel bricks.");
	messageClient(%client,'',"<color:00ff00>*When placing a door, you should use the event hotelDoorCheck to determine if the door should open or not.");
	messageClient(%client,'',"<color:00ff00>*When placing a door, give it the name Door_ROOM. Replace ROOM with the room number.");
	messageClient(%client,'',"<color:00ff00>*When placing a floor teleport, make sure you change the end of its name to the floor number. Letters can work too. Example: Floor_L");
	messageClient(%client,'',"<color:00ff00>*When placing a room teleport, make sure you change the end of its name to the room number. Letters do NOT work.");
	messageClient(%client,'',"When saving, make sure you save ownership. When loading, make sure you load ownership. VERY IMPORTANT!");
}
